/* ***************************************************************************
   *                                                                         *
   *   Kindermann                        Wahlpflichtkurs Produktentwicklung  *
   *                                     Schuljahr: 2014-15                  *
   *                                                                         *
   *                             AVR-Flashtool 1.6                           *
   *                                                                         *
   *                         (Crossplattform-Version)                        *
   *                                                                         *
   ***************************************************************************/


#ifndef ABOUTAPP_H
#define ABOUTAPP_H

#include <wx/wxprec.h>
#include <wx/wx.h>


enum {myID_ABOUTTIMER};


const wxString APP_NAME = _T("AVR-Flashtool");
const wxString APP_VERSION = _T("Version 1.6");
const wxString APP_COPYRIGHT = _T(" Dietrich Kindermann 2015");


class AppFrame: public wxFrame {
    friend class App;
    friend class AppAbout;
    friend class AppHelp;

public:

    AppFrame (const wxString &title);


    ~AppFrame ();

    void OnExit (wxCommandEvent &event);
    void OnTimerEvent (wxTimerEvent &event);

private:

    DECLARE_EVENT_TABLE()
};


class AppAbout: public wxDialog {

public:
    AppAbout (wxWindow *parent,
              int milliseconds = 0);

    ~AppAbout ();

    void OnTimerEvent (wxTimerEvent &event);

private:
    wxTimer *m_timer;

    DECLARE_EVENT_TABLE()
};

#endif  // ABOUTAPP_H
