/* ***************************************************************************
   *                                                                         *
   *   Kindermann                        Wahlpflichtkurs Produktentwicklung  *
   *                                     Schuljahr: 2014-15                  *
   *                                                                         *
   *                             AVR-Flashtool 1.6                           *
   *                                                                         *
   *                         (Crossplattform-Version)                        *
   *                                                                         *
   ***************************************************************************/


#ifndef CBOOT_h
#define CBOOT_h

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <string.h>

#include <wx/wx.h>
#include <wx/panel.h>

#include "usb.h"
#include "cpage.h"
#include "communicate.h"

//#define USBDEV_SHARED_VENDOR    0x16C0  /* VOTI */
//#define USBDEV_SHARED_PRODUCT   0x05DC  /* Obdev's free shared PID */

#define USBDEV_SHARED_VENDOR    0x16D0  /* Digispark */
#define USBDEV_SHARED_PRODUCT   0x0753  /* Obdev's free shared PID */


class CBootloader : public wxPanel{
 public:
  CBootloader(Communicate* comm);
  ~CBootloader();

  unsigned int error;


  /******************************************************************************
  * MicronucleusFunction prototypes
  ******************************************************************************/

  int parseRaw(char *hexfile, unsigned char *buffer, int *startAddr, int *endAddr);
  int parseIntelHex(char *hexfile, unsigned char *buffer, int *startAddr, int *endAddr); /* taken from bootloadHID example from obdev */
  int parseUntilColon(FILE *fp); /* taken from bootloadHID example from obdev */
  int parseHex(FILE *fp, int numDigits); /* taken from bootloadHID example from obdev */

  void setProgressData(char* friendly, int step);
  micronucleus* micronucleus_connect(Communicate* comm);

  int MicronucleusWriteFlash();

  void WriteFlash();
  unsigned int getPagesize(Communicate* comm);
  void writePage(CPage* page, Communicate* comm);

  void startApplication(Communicate* comm);
  void OnFlashClick(wxCommandEvent & event);
  void OnFindDeviceClick(wxCommandEvent & event);
  void OnTetrisClick(wxCommandEvent & event);
  void OnPacmanClick(wxCommandEvent & event);
  void OnMarioClick(wxCommandEvent & event);
  void OnPongClick(wxCommandEvent & event);

 protected:
  usb_dev_handle *usbhandle;
};

#endif
