/* ***************************************************************************
   *                                                                         *
   *   Kindermann                        Wahlpflichtkurs Produktentwicklung  *
   *                                     Schuljahr: 2014-15                  *
   *                                                                         *
   *                             AVR-Flashtool 1.6                           *
   *                                                                         *
   *                         (Crossplattform-Version)                        *
   *                                                                         *
   ***************************************************************************/


#include "cpage.h"

CPage::CPage(unsigned int pageaddress, unsigned int pagesize) {

  assert(pagesize > 0);

  m_nPagesize = pagesize;
  m_nPageaddress = pageaddress - (pageaddress % m_nPagesize);

  m_pData = new unsigned char[m_nPagesize];
  memset(m_pData, 0xff, m_nPagesize);

  m_pPrevpage = NULL;
  m_pNextpage = NULL;
}

CPage::~CPage() {
  assert(m_pData);
  delete m_pData;
}

unsigned int CPage::getPageaddress() {
  return m_nPageaddress;
}

unsigned int CPage::getPagesize(Communicate* comm) {
  return m_nPagesize;
}

unsigned char * CPage::getData() {
  return m_pData;
}

CPage* CPage::getPrev() {
  return m_pPrevpage;
}

CPage* CPage::getNext() {
  return m_pNextpage;
}

void CPage::setPrev(CPage* pPage) {
  m_pPrevpage = pPage;
}

void CPage::setNext(CPage* pPage) {
  m_pNextpage = pPage;
}

CPage* CPage::insert(unsigned int nAddress, unsigned char bValue) {
  assert(m_nPageaddress == (nAddress - (nAddress % m_nPagesize)));
  m_pData[nAddress % m_nPagesize] = bValue;
}

void CPage::display(Communicate* comm) {
  int n;
   comm->m_rp->m_textCtrl3->AppendText("Adresse der Seite: "
   + wxString::Format(wxT("%d"),(int)getPageaddress())+"\n");
  for (n = 0; n < 64; n++)
   comm->m_rp->m_textCtrl3->AppendText(wxString::Format(wxT("%2X"),(int)m_pData[n]+"\n"));
   comm->m_rp->m_textCtrl3->AppendText("\n----ENDE DER SEITE----\n");
}

