/* ***************************************************************************
   *                                                                         *
   *   Kindermann                        Wahlpflichtkurs Produktentwicklung  *
   *                                     Schuljahr: 2014-15                  *
   *                                                                         *
   *                             AVR-Flashtool 1.6                           *
   *                                                                         *
   *                         (Crossplattform-Version)                        *
   *                                                                         *
   ***************************************************************************/


#include <wx/wx.h>
#include <wx/wxprec.h>
#include <wx/hyperlink.h>
#include <wx/dialog.h>
#include <wx/textctrl.h>
#include <wx/statbox.h>

#if wxUSE_FILESYSTEM
#include <wx/fs_inet.h>
#include "wx/filesys.h"
#include "wx/fs_mem.h"
#endif

#include "main.h"
#include "communicate.h"
#include "aboutapp.h"

wxString *g_appname = NULL;

IMPLEMENT_APP(MyApp)

bool MyApp::OnInit()
{
    // Add handlers
    wxImage::AddHandler( new wxPNGHandler );

    wxImage::AddHandler( new wxJPEGHandler );

    wxImage::AddHandler( new wxGIFHandler );

    wxFileSystem::AddHandler( new wxMemoryFSHandler );

    wxFileSystem::AddHandler(new wxInternetFSHandler);

    SetAppName (APP_NAME);
    g_appname = new wxString ();
    g_appname->Append (APP_NAME);

    AppAbout (NULL, 3000);

    Communicate *communicate = new Communicate(wxT("AVR-Flashtool"));
    communicate->Show(true);

    return true;
}
